{-# OPTIONS --type-in-type #-}
module nvec-map where

-- N-ary MAP just for vectors

open import Data.Vec hiding (_⊛_)
open import Data.Vec1
open import Data.List hiding (zip)
open import Data.Nat
open import Data.Unit
open import Data.Product hiding (zip)
open import Data.Bool

open import local-lib

arrTy : {n : ℕ} → Vec₁ Set (suc n) → Set
arrTy {0}      (A ∷ [])  = A
arrTy {suc n}  (A ∷ As)  = A → arrTy As

arrTyVec  : {m n : ℕ} → Vec₁ Set (suc n) → Set
arrTyVec {m} As = 
  arrTy (repeat₁ (\ A → Vec A m) ⊛₁ As )

nvec-map  : {m : ℕ} → (n : ℕ) 
          → (As : Vec₁ Set (suc n)) 
          → arrTy As → arrTyVec {m} As

nvec-map n As f = g {n} As (repeat f) where
  g  : {n m : ℕ} 
     → (As : Vec₁ Set (suc n)) 
     → Vec (arrTy As) m → arrTyVec {m} As
  g  {0}      (A ∷ [])   a  = a
  g  {suc n}  (A1 ∷ As)  f  = 
        (\ a → g As (f ⊛ a))

nmap  : (n : ℕ) → {m : ℕ}
      → ∀⇒ (\(As : Vec₁ Set (suc n))
      → arrTy As → arrTyVec {m} As )
nmap n {m} =  \⇒ (nvec-map {m} n)

